use ExtUtils::MakeMaker;

# ExtUtils::AutoInstall Bootstrap Code, version 7.
BEGIN{my$p='ExtUtils::AutoInstall';my$v=0.45;$p->VERSION||0>=$v
or+eval"use $p $v;1"or+do{my$e=$ENV{PERL_EXTUTILS_AUTOINSTALL};
(!defined($e)||$e!~m/--(?:default|skip|testonly)/and-t STDIN or
eval"use ExtUtils::MakeMaker;WriteMakefile(PREREQ_PM=>{'$p',$v}
);1"and exit)and print"==> $p $v required. Install it from CP".
"AN? [Y/n] "and<STDIN>!~/^n/i and print"*** Installing $p\n"and
do{if (eval '$>' and lc(`sudo -V`) =~ /version/){system('sudo',
$^X,"-MCPANPLUS","-e","CPANPLUS::install $p");eval"use $p $v;1"
||system('sudo', $^X, "-MCPAN", "-e", "CPAN::install $p")}eval{
require CPANPLUS;CPANPLUS::install$p};eval"use $p $v;1"or eval{
require CPAN;CPAN::install$p};eval"use $p $v;1"||die"*** Please
manually install $p $v from cpan.org first...\n"}}}

sub parse_arg {
  my($val, $name) = (@_);
  if ($val =~ /^($name)=["']?(.*?)["']?$/) {
    return $2;
  } else {
    return undef;
  }
}

my %opt = (
  'cgidir'     => undef,
);

ARGV: foreach (@ARGV) {
  foreach my $key (keys %opt) {
    my $val = parse_arg($_, uc($key));
    if (defined $val) {
      $opt{$key} = $val;
      next ARGV;
    }
  }
}

if (!defined $opt{'cgidir'}) {
  $opt{'cgidir'} = prompt(
    "You must provide a location for installing the PAPI Authentication\n".
    "Server software. It must be a directory configured to hold CGI\n".
    "programs in your Apache installation:", "/usr/local/apache/cgi-bin"
  );
  print "\n";
}
$cgidir = $opt{'cgidir'};
print "The Authentication Server CGI will be in $cgidir/AuthServer\n";
print "The configuration file will be $cgidir/AuthServer.cf\n";
print "Other data files will be installed under $cgidir/etc/ and $cgidir/www/\n";

use ExtUtils::AutoInstall (
	-config => [            # Configurations for the AutoInstall process
  	#'makepl_arg' => 'PREFIX=/tmp/MyPerlLibraries LIB=/tmp/MyPerlLibraries',  # Prefix path for al the instalations paths?
    'prerequisites_policy' => 'ask',
  ],

 'TESTs' => [
  	-default    => 1,
        Class::Accessor => '',
        Regexp::Common => '',
  ],

 'CGI' => [
	-default    => 1,
		CGI => '',
		CGI::Lite => '',
 ],
  
 'Crypt' => [
	-default    => 1,
		Crypt::CBC => '',
		Crypt::OpenSSL::RSA => '0.24',
		Crypt::Rijndael => '',
 ],

 'HTTP' => [
    -default    => 1,
		LWP::UserAgent => '',
		URI::Escape => '',
 ],

 'Net' => [
	-default    => 1,
		Net::IMAP::Simple => '',
		Net::LDAP => '',
		Net::LDAP::Entry => '',
		Net::LDAP::Message => '',
		Net::LDAP::Search => '',
 ],
 
 'System' => [
	-default    => 1,
		Sys::Syslog => '',
		Time::Local => '',
		Fcntl => '',
 ],
 
 'DB' => [
	-default    => 1,
		MLDBM => '',
		MLDBM::Sync => '',
		DB_File => '',
		DB_File::Lock => '',
 ],
 
 'Miscelaneous' => [
	-default    => 1,
		Digest::MD5 => '',
		Mail::POP3Client => '',
		MIME::Base64 => '',
 ],
);


WriteMakefile(
  'NAME' => 'PAPI',
  'MAN1PODS' => {},
  'MAN3PODS' => {},
  'VERSION' => '1.5',
);


sub MY::install {
  package MY;
  my $inherited = shift->SUPER::install(@_);
  $inherited =~ s/^(\t+)(\$\(INST_SCRIPT\) \$\((DEST)?INSTALLSCRIPT\))/$1\$(INST_CGI) \$(INSTALLCGI) \\\n$1$2/gsm;
  $inherited =~ s/^(\t+)(\$\(INST_SCRIPT\) \$\((DEST)?INSTALLSITESCRIPT\))/$1\$(INST_CGI) \$(INSTALLCGI) \\\n$1$2/gsm;
  $inherited;
}

sub MY::installbin {
  package MY;
  my $self = shift;
  my $inherited = $self->SUPER::installbin(@_);
  $inherited = "INST_CGI = ".$self->{INST_SCRIPT}."/../cgi\nINSTALLCGI = ".$cgidir."\n".$inherited;
  print $inherited;
  $inherited;
}

